'Demo for using nveiwlib.dll with LB3.
'This DLL will load bitmaps, jpgs and other image types.
'
'Original program by Alyce Watson, 2001.
'You may use code from this program in your
'own programs, but you may not redistribute
'this program.

    nomainwin

    UpperLeftX = int((DisplayWidth- 640)/2)
    UpperLeftY = int((DisplayHeight- 480)/2)
    WindowWidth = 640
    WindowHeight = 480
    graphicbox #1.g, 0, 0, 638, 440

    MENU #1, "&File", "&Open Image", [choose.image],_
    "&Save as Bmp",[save],"Save as &Jpg",[jpg], | ,_
    "E&xit", [quit]

    MENU #1, "&Help", "&About", [about]

open "Liberty BASIC Image Viewer" for window_nf as #1

    print #1,"trapclose [quit]"

[startup]
    open "NViewLib.dll"for DLL as #nv

[loop]
    wait


[choose.image]
    filedialog "Open image file", "*.JPG;*.JIF;*.GIF;*.BMP;*.DIB;*.RLE;*.TGA;*.PCX", file$
    if file$="" then [loop]

[newpic]
    if hImage<>0 then
        unloadbmp "pic"
    end if

    print #1.g, "cls" 'clear graphicbox and release flushed memory

    calldll #nv, "NViewLibLoad",_
    file$ AS ptr,_
    1 AS short,_    '1 enables progress bar.  0 disables it
    hImage AS ulong 'handle of loaded bitmap

    if hImage<>0 then
        loadbmp "pic", hImage
        print #1.g, "drawbmp pic 0 0; flush"
    else
        notice "Error loading image!"
    end if

    wait


[save]
    filedialog, "Save as...","*.bmp",savefile$
    if savefile$="" then [loop]
    savefile$=lower$(savefile$)
    if right$(savefile$,4)<>".bmp" then
        savefile$=savefile$+".bmp"
    end if

    bmpsave "pic", savefile$
    wait

[jpg]
    filedialog, "Save as...","*.jpg",savefile$
    if savefile$="" then [loop]
    calldll #nv, "NViewLibSaveAsJPG",100 as long,_
    savefile$ as ptr,r as long
    if r=0 then notice "Error saving as jpg!"
    wait


[quit]
    close #nv:close #1
    end

[about]
    msg$="Liberty BASIC Image Viewer" + chr$(13) + _
    "This program loads images in many formats by using " +  _
    "the freeware DLL, nviewlib.dll.  Displaying the loaded " + _
    "images can now be done with native LB.  In LB3 it is possible " + _
    "to save these images as bitmaps. " + chr$(13 )+ chr$(13) + chr$(169) + _
    " Alyce Watson, 2001." + chr$(13) + chr$(13) + _
    "You may use these techniques in your own programs, but you " + _
    "may not redistribute this program."
    notice msg$
    goto [loop]
